#!/usr/bin/ruby -w
# -*- coding : utf-8 -*-

require 'zlib'
require_relative 'log_deserializer'

class CompileCommand

    def getCompileCommand(xcactivitylog, compile_file, output_file)
        ret = false
        if File.directory?(xcactivitylog)
            path = "#{xcactivitylog}/*.xcactivitylog"
            files_sorted_by_time = Dir[path].sort!{ |x,y| File.mtime(y) <=> File.mtime(x) }
            files_sorted_by_time.each do |file|
                ret = getCompileCommandFromLog(file, compile_file, output_file)
                if ret
                    break
                end
            end
        else
            ret = getCompileCommandFromLog(xcactivitylog, compile_file, output_file)
        end
    end

    def getCompileCommandFromLog(xcactivitylog, compile_file, output_file)
        ext = File.extname(compile_file)
        file = File.basename(compile_file, ext)
        file = "#{file}.o"

        output_file = "#{output_file}.sh"

        # filter compile command
        reg = ".*clang+.*Applications(.*o)"

        # prase slf0 and filter the command
        flag = false
        text = XcodeResultBundleProcessor::Logdeserializer.deserialize_action_logs(xcactivitylog)
        text.each do |item|
            # puts item
            # if item =~ reg && item =~ /#{file}/
            if item =~ /#{file}/
                content = item.match(reg)
                if content
                    puts content

                    writeFile(output_file, content)
                    flag = true
                    break
                end
            end
        end

        flag
    end

    def writeFile(file, content)
        aFile = File.new(file, "w+")
        if aFile
            aFile.syswrite(content)
        end
    end
end

# ARGV[0] xcactivitylog folder path or file path
# ARGV[1] compile file full path
# ARGV[2] out put file path
#  CompileCommand.new().getCompileCommand(ARGV[0], ARGV[1], ARGV[2])
