require_relative 'tokenizer'
require_relative 'class_name_resolver'
require_relative 'deserializer'

module XcodeResultBundleProcessor
  module Logdeserializer
    include XcodeResultBundleProcessor::SLF0::Tokenizer
    def self.deserialize_action_logs(xcactivitylog)
  
      File.open(xcactivitylog, "r") do |activity_log_io|
        io     = Zlib::GzipReader.new(activity_log_io)
        tokens = XcodeResultBundleProcessor::SLF0::Tokenizer.read_token_stream(io)
        tokens = XcodeResultBundleProcessor::SLF0::ClassNameResolver.resolve_class_names(tokens).to_a
      end
    end
  end
end
